package com.example.selenium.demo.Service;

import org.openqa.selenium.UnhandledAlertException;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.chrome.ChromeOptions;


public class ModifiedChromeDriver extends ChromeDriver {
//public class ModifiedChromeDriver extends RemoteWebDriver {

    private boolean isLocked = false;

    public ModifiedChromeDriver(ChromeOptions chromeOptions){
        super(chromeOptions);
    }

//    public ModifiedChromeDriver(URL url, DesiredCapabilities capabilities) {
//        super(url, capabilities);
//    }

    public synchronized void lock(){
        this.isLocked =true;
    }

    public synchronized void unLock(){
        this.isLocked =false;
    }

    public synchronized boolean isLock(){
        return this.isLocked;
    }

    public synchronized void release(){
        //重置浏览器状态
        try {
            this.navigate().to("about:blank");
        }catch (UnhandledAlertException e){
            //防止页面弹出alert 导致充值异常
            this.switchTo().alert().dismiss();
            this.navigate().to("about:blank");
        }
        unLock();
    }

}
