package com.example.selenium.demo.Service;

import org.openqa.selenium.remote.DesiredCapabilities;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.net.MalformedURLException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;


public class RemoteChromeDriver {

    private static Logger logger = LoggerFactory.getLogger(RemoteChromeDriver.class);

    public static ModifiedChromeDriver getDriver() throws MalformedURLException, IOException {
        Properties properties = new Properties();
        properties.load(ChromeSeleniumDriverPool.class.getResourceAsStream("/config/config-mapping.properties"));
        String removeUrl = properties.getProperty("chromedriver.remoteurl");
        logger.info("正在调用远程Chrome : " + removeUrl);
        DesiredCapabilities capabilities = DesiredCapabilities.chrome();
        String[] options = new String[]{"--headless", "--no-sandbox", "--disable-gpu"};
        Map map = new HashMap();
        map.put("args", options);
        capabilities.setCapability("chromeOptions", map);
//        return new ModifiedChromeDriver(new URL(removeUrl), capabilities);
        return null;
    }
}
