package com.example.selenium.demo.Service;

import net.sf.json.JSONObject;
import okhttp3.Response;
import org.apache.commons.io.FileUtils;
import org.openqa.selenium.*;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

/**
 * @author ：Nick
 * @date ：Created in 2019/7/19 11:48
 */
public class Test {
	private static Logger logger= LoggerFactory.getLogger(Test.class);
	public static void main(String[] args) {
		try {
			ChromeSeleniumDriverPool pool = new ChromeSeleniumDriverPool();
			ModifiedChromeDriver chromeDriver = ChromeSeleniumDriverPool.getDriver();
			WebDriverWait webDriverWait = new WebDriverWait(chromeDriver, 30);
			By loginName = By.id("loginName");
			By loginPwd = By.id("loginPwd");
			By tempValidateCode = By.id("tempValidateCode");
			By userLoginBtn = By.id("userLoginBtn");
			By btnclose = By.id("btnclose");
			logger.info("访问地址："+"http://59.37.20.98");
			//打开浏览器
			chromeDriver.get("http://59.37.20.98");
			//关闭弹出框
			WebElement element = webDriverWait.until(ExpectedConditions.elementToBeClickable(btnclose));
			if (element != null) {
				chromeDriver.findElement(btnclose).click();
			}
			//点击登录按钮
			if (Utils.isElementExist(chromeDriver, By.xpath("//a[contains(text(),'登录')]"))) {
				chromeDriver.findElementByXPath("//a[contains(text(),'登录')]").click();
			}
			WebElement ele = chromeDriver.findElement(By.id("codeIm"));
			//屏幕截图
			File screenshot = ((TakesScreenshot) chromeDriver).getScreenshotAs(OutputType.FILE);
			BufferedImage fullImg = ImageIO.read(screenshot);

			Point point = ele.getLocation();

			int eleWidth = ele.getSize().getWidth();
			int eleHeight = ele.getSize().getHeight();

			BufferedImage eleScreenshot = fullImg.getSubimage(point.getX(), point.getY(),
					eleWidth, eleHeight);
			ImageIO.write(eleScreenshot, "png", screenshot);

			File screenshotLocation = new File("D:\\logs\\a.png");
			FileUtils.copyFile(screenshot, screenshotLocation);
			byte[] bytes = Utils.image2byte("D:\\logs\\a.png");
			//输入账号
			logger.info("账号："+"");
			wait(chromeDriver, loginName);
			chromeDriver.findElement(loginName).sendKeys("");
			//输入密码
			wait(chromeDriver, loginPwd);
			chromeDriver.findElement(loginPwd).sendKeys("");
			logger.info("密码："+"");
			JSONObject verificationCode = Utils.getVerificationCode(Utils.getParam(), "http://v1-http-api.jsdama.com/api.php?mod=php&act=upload", bytes);
			//获取验证码，通过联众
			String code = (String) JSONObject.fromObject(verificationCode.get("data").toString()).get("val");
			logger.info("验证吗："+code);
			wait(chromeDriver, tempValidateCode);
			chromeDriver.findElement(tempValidateCode).sendKeys(code);
			logger.info("登录成功！");
			element = webDriverWait.until(ExpectedConditions.elementToBeClickable(userLoginBtn));
			if (element != null)
				chromeDriver.findElement(userLoginBtn).click();


		} catch (IOException e) {
			e.printStackTrace();
		}

//		WebElement element = webDriverWait.until(ExpectedConditions.elementToBeClickable(loginName));
//		if(element != null)
//			chromeDriver.findElement(loginName).click();

		System.out.println("end");
	}


	public static WebDriverWait wait(ModifiedChromeDriver chromeDriver, By by) {
		WebDriverWait webDriverWait = new WebDriverWait(chromeDriver, 30);
		webDriverWait.until(ExpectedConditions.presenceOfElementLocated(by));
		return webDriverWait;
	}
}
