package com.example.selenium.demo.Service;

import net.sf.json.JSONObject;
import okhttp3.*;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.imageio.stream.FileImageInputStream;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.*;

/**
 * @author ：Nick
 * @date ：Created in 2019/7/19 14:30
 */
public class Utils {
	public static JSONObject getVerificationCode(Map<String, String> paramMap, String uri, byte[] buffer){
		JSONObject result = new JSONObject();
		try{
			String BOUNDARY = "---------------------------68163001211748"; //boundary就是request头和上传文件内容的分隔符
			URL url=new URL(uri);
			HttpURLConnection connection=(HttpURLConnection)url.openConnection();
			connection.setDoInput(true);
			connection.setDoOutput(true);
			connection.setRequestMethod("POST");
			connection.setRequestProperty("content-type", "multipart/form-data; boundary="+BOUNDARY);
			connection.setConnectTimeout(30000);
			connection.setReadTimeout(30000);

			// 普通参数
			OutputStream out = new DataOutputStream(connection.getOutputStream());
			if (paramMap != null) {
				StringBuffer strBuf = new StringBuffer();
				Iterator<Map.Entry<String, String>> iter = paramMap.entrySet().iterator();
				while (iter.hasNext()) {
					Map.Entry<String,String> entry = iter.next();
					String inputName = entry.getKey();
					String inputValue = entry.getValue();
					strBuf.append("\r\n").append("--").append(BOUNDARY).append("\r\n");
					strBuf.append("Content-Disposition: form-data; name=\""
							+ inputName + "\"\r\n\r\n");
					strBuf.append(inputValue);
				}
				out.write(strBuf.toString().getBytes());
			}

			//图片
			String filename="code.jpg";
			String contentType = "image/jpeg";//这里看情况设置
			StringBuffer strBuf = new StringBuffer();
			strBuf.append("\r\n").append("--").append(BOUNDARY).append("\r\n");
			strBuf.append("Content-Disposition: form-data; name=\""
					+ "upload" + "\"; filename=\"" + filename+ "\"\r\n");
			strBuf.append("Content-Type:" + contentType + "\r\n\r\n");
			out.write(strBuf.toString().getBytes());
			out.write(buffer);
			byte[] endData = ("\r\n--" + BOUNDARY + "--\r\n").getBytes();
			out.write(endData);
			out.flush();
			out.close();

			//读取URLConnection的响应
			InputStream in = connection.getInputStream();
			ByteArrayOutputStream bout = new ByteArrayOutputStream();
			byte[] buf = new byte[1024];
			while (true) {
				int rc = in.read(buf);
				if (rc <= 0) {
					break;
				} else {
					bout.write(buf, 0, rc);
				}
			}
			in.close();
			result=JSONObject.fromObject(new String(bout.toByteArray()));
		}catch (Exception e){
			Logger logger = LoggerFactory.getLogger(Utils.class);
			logger.error("联众接口获取验证码信息失败:{}",e.getMessage());
		}
		return result;

	}

	public static Map<String, String> getParam() {
		Map<String, String> paramMap = new HashMap<>();
		paramMap.put("user_name", "ida_9045");
		paramMap.put("user_pw", "ida_904511");
		paramMap.put("yzm_minlen", "4");
		paramMap.put("yzm_maxlen", "4");
		paramMap.put("yzmtype_mark", "0");
		paramMap.put("zztool_token", "123");
		return paramMap;
	}


	public static Response getpic(){
		OkHttpClient client = new OkHttpClient();
		Response response=null;
		Request request = new Request.Builder()
				.url("http://tyrz.gdbs.gov.cn/am/imageServlet?id=0.13354373141839204")
				.get()
				.addHeader("Postman-Token", "c47d9d53-a629-40e5-9063-5b8601a66aa9,b63da925-7676-4dc6-9539-a9fdd1a87813")
				.addHeader("Host", "tyrz.gdbs.gov.cn")
				.build();

		try {
			 response = client.newCall(request).execute();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return response;
	}




	public static List getDataForHtml(String url) {
		OkHttpClient client = new OkHttpClient();
		MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded; charset=UTF-8");
		RequestBody body = RequestBody.create(mediaType, "");

		Request request = new Request.Builder()
				.url(url)
				.post(body)
				.addHeader("content-type", "application/x-www-form-urlencoded;charset=UTF-8;")
				.build();
		String str = null;
		try {
			Response response = client.newCall(request).execute();
			str = response.body().string();
			Document contents = Jsoup.parse(str);
			Elements areaContents = contents.getElementsByTag("a");

			for (Element target : areaContents) {
				String mc = target.attr("onclick");
				String value = mc.substring(mc.indexOf("'") + 1, mc.lastIndexOf("'"));
				String regionName = target.text();

			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

		public void test(){
//			driver.get("http://www.google.com");
//			WebElement ele = driver.findElement(By.id("hplogo"));
//
//			// Get entire page screenshot
//			File screenshot = ((TakesScreenshot)driver).getScreenshotAs(OutputType.FILE);
//			BufferedImage  fullImg = ImageIO.read(screenshot);
//
//			// Get the location of element on the page
//			Point point = ele.getLocation();
//
//			// Get width and height of the element
//			int eleWidth = ele.getSize().getWidth();
//			int eleHeight = ele.getSize().getHeight();
//
//		// Crop the entire page screenshot to get only element screenshot
//			BufferedImage eleScreenshot= fullImg.getSubimage(point.getX(), point.getY(),
//					eleWidth, eleHeight);
//			ImageIO.write(eleScreenshot, "png", screenshot);
//
//			// Copy the element screenshot to disk
//			File screenshotLocation = new File("C:\\images\\GoogleLogo_screenshot.png");
//			FileUtils.copyFile(screenshot, screenshotLocation);
		}
	//图片到byte数组
	public static byte[] image2byte(String path){
		byte[] data = null;
		FileImageInputStream input = null;
		try {
			input = new FileImageInputStream(new File(path));
			ByteArrayOutputStream output = new ByteArrayOutputStream();
			byte[] buf = new byte[1024];
			int numBytesRead = 0;
			while ((numBytesRead = input.read(buf)) != -1) {
				output.write(buf, 0, numBytesRead);
			}
			data = output.toByteArray();
			output.close();
			input.close();
		}
		catch (FileNotFoundException ex1) {
			ex1.printStackTrace();
		}
		catch (IOException ex1) {
			ex1.printStackTrace();
		}
		return data;
	}

	public static boolean isElementExist(ModifiedChromeDriver driver, By locator){
		try {
			driver.findElement(locator);
			return true;
		}catch (UnhandledAlertException e) {
			throw e;
		} catch (Exception e) {
			return false;
		}

	}
}
